package com.fp.persistence.pgeneral.score;

import java.sql.Timestamp;
import java.util.List;
import java.io.Serializable;
import javax.persistence.Table;
import java.math.BigDecimal;

import com.fp.common.helper.Constant;
import com.fp.dto.hb.HibernateBean;

import javax.persistence.Query;
import javax.persistence.Version;
import javax.persistence.Entity;
import javax.persistence.EmbeddedId;
import com.fp.dto.hb.Cache;

import javax.persistence.EntityManager;
import javax.persistence.Column;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**
 * Clase que implementa la entidad de Hibernate que hace referencia a la tabla
 * TGENEPERCENTSCORE
 */
@Entity(name = "TgenePercentScore")
@Table(name = "TGENEPERCENTSCORE")
public class TgenePercentScore extends com.fp.dto.AbstractDataTransport
		implements Serializable, HibernateBean, Cloneable, Cache {
	/**
	 * HashCode asociado con la Instancia
	 */
	@Transient
	private int hashValue = 0;
	/**
	 * Version de la Clase
	 */
	private static final long serialVersionUID = 1L;
	/**
	 * Clave primaria de la Entidad TgenePercentScore
	 */
	@EmbeddedId
	private TgenePercentScoreKey pk;
	@Column(name = "DATEFROM", nullable = true)
	/**
	 * Fecha desde la cual esta vigente el porcentaje de calificacion
	 */
	private Timestamp datefrom;

	@Version
	@Column(name = "RECORDVERSION", nullable = true)
	/**
	 * Optimistick locking del registro.
	 */
	private Integer recordversion;

	@Column(name = "PERCENT", nullable = true)
	/**
	 * Porcentaje de provision de la calificacion tipo de credito
	 */
	private BigDecimal percent;

	/** Contructor por defecto */
	public TgenePercentScore() {
	}

	/**
	 * Contructor de TgenePercentScore
	 * 
	 * @param pPk
	 *            Clave Primaria del entity
	 */
	public TgenePercentScore(TgenePercentScoreKey pPk) {
		this();
		pk = pPk;
	}

	/**
	 * Metodo que entrega datos de la tabla dada la clave primaria.
	 * 
	 * @param pEntityManager
	 *            referencia de la session a obtener datos del bean.
	 * @param pKey
	 *            Caleve primaria del bean.
	 * @return TgenePercentScore
	 */
	public static TgenePercentScore find(EntityManager pEntityManager,
			TgenePercentScoreKey pKey) throws Exception {
		TgenePercentScore obj = pEntityManager.find(TgenePercentScore.class,
				pKey);
		return obj;
	}

	/**
	 * Entrega la Clave primaria de TgenePercentScore
	 * 
	 * @return El objeto que referencia a la Clave primaria de TgenePercentScore
	 */
	public TgenePercentScoreKey getPk() {
		return pk;
	}

	/**
	 * Fija un nuevo valor a la Clave primaria de TgenePercentScore
	 * 
	 * @param pPk
	 *            El objeto que referencia a la nueva Clave primaria de
	 *            TgenePercentScore
	 */
	public void setPk(TgenePercentScoreKey pPk) {
		pk = pPk;
	}

	/**
	 * Obtiene el valor de datefrom
	 * 
	 * @return valor de datefrom
	 */
	public Timestamp getDatefrom() {
		return datefrom;
	}

	/**
	 * Fija el valor de datefrom
	 * 
	 * @param pDatefrom
	 *            nuevo Valor de datefrom
	 */
	public void setDatefrom(Timestamp pDatefrom) {
		datefrom = pDatefrom;
	}

	/**
	 * Obtiene el valor de recordversion
	 * 
	 * @return valor de recordversion
	 */
	public Integer getRecordversion() {
		return recordversion;
	}

	/**
	 * Fija el valor de recordversion
	 * 
	 * @param pRecordversion
	 *            nuevo Valor de recordversion
	 */
	public void setRecordversion(Integer pRecordversion) {
		recordversion = pRecordversion;
	}

	/**
	 * Obtiene el valor de percent
	 * 
	 * @return valor de percent
	 */
	public BigDecimal getPercent() {
		return percent;
	}

	/**
	 * Fija el valor de percent
	 * 
	 * @param pPercent
	 *            nuevo Valor de percent
	 */
	public void setPercent(BigDecimal pPercent) {
		percent = pPercent;
	}

	public boolean equals(Object rhs) {
		if (rhs == null)
			return false;
		if (!(rhs instanceof TgenePercentScore))
			return false;
		TgenePercentScore that = (TgenePercentScore) rhs;
		if (this.getPk() == null || that.getPk() == null)
			return false;
		return (this.getPk().equals(that.getPk()));
	}

	/**
	 * Implementación del metodo hashCode de la la entidad TgenePercentScore
	 * 
	 * @return el hashCode la instancia
	 */
	public int hashCode() {
		if (this.hashValue == 0) {
			int result = 17;
			if (this.getPk() == null) {
				result = super.hashCode();
			} else {
				result = this.getPk().hashCode();
			}
			this.hashValue = result;
		}
		return this.hashValue;
	}

	/** Implementación toString */
	public String toString() {
		Field[] fs = this.getClass().getDeclaredFields();
		String data = "";
		for (Field f : fs) {
			try {
				String name = f.getName();
				if (f.getType().getName().compareTo("java.util.Set") == 0)
					continue;
				if (name.compareTo("hashValue") == 0
						|| name.compareTo("serialVersionUID") == 0)
					continue;
				data += name + "=" + f.get(this) + ";";
			} catch (Exception e) {
				continue;
			}
		}
		if (data.compareTo("") == 0) {
			data = super.toString();
		}
		return data;
	}

	/** Implementación de la creación de un bean en blanco TgenePercentScore */
	public Object createInstance() {
		TgenePercentScore instance = new TgenePercentScore();
		instance.setPk(new TgenePercentScoreKey());
		return instance;
	}

	/**
	 * Clona la entidad TgenePercentScore
	 * 
	 * @see com.fp.dto.hb.HibernateBean#cloneMe()
	 */
	public Object cloneMe() throws CloneNotSupportedException {
		TgenePercentScore p = (TgenePercentScore) this.clone();
		p.setPk((TgenePercentScoreKey) this.pk.cloneMe());
		return p;
	}

	public Object getId() {
		return this.pk;
	}
	
	
	/**
	 * 
	 *  METODOS MANUALES
	 *  
	 */
		
	private static final String JPQL_SCORE_PERCENT = "" +
			"  from TgenePercentScore tsol                                           " +
			"  where tsol.pk.dateto = :dateto                                        " +
			"    and tsol.pk.credittypecode = :credittype                            " +
			"    and tsol.percent <= :percent                                        ";

	public static List<TgenePercentScore> findbyScorePercent(EntityManager pEntityManager, String credittype, Number percent) throws Exception{
		//javax.persistence.Query qry = pEntityManager.createQuery(JPQL_SCORE_PERCENT);
		Query qry = pEntityManager.createQuery(JPQL_SCORE_PERCENT);
		qry.setParameter("credittype", credittype);
        qry.setParameter("dateto", Constant.getDefaultExpiryDate());
        qry.setParameter("percent", percent);
        
        return qry.getResultList(); 
    }
	
}
